#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w

###############################################################################
# Required inclusions
###############################################################################
use strict;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Reports;
use HTML::Entities;

###############################################################################
# Get the response object
###############################################################################
my $response = $REQUEST->get_response(
                    'PureMessage::Manager::Response::Reports',
                    'stderr_to_stdout' => 1,
                    );
exit unless $response;

eval {
###############################################################################
# Add online help pages
###############################################################################
$response->add_help(text => "Help", tab => "rep", page => "mgr_rep_over" );

###############################################################################
# List all known views and their appropriate actions.
###############################################################################
    my %views = (
                 'dashboard' => sub { $response->show_dashboard() },
                 'list'      => sub { $response->show_report_list() },
                 'report'    => sub { $response->show_report(%in) },
                 );

###############################################################################
# Figure out what view we've been asked to show.
###############################################################################
    my $view = $in{'v'} if ($in{'v'});
    $view = 'dashboard' unless ($view);

###############################################################################
# Execute the actions required for this view.
###############################################################################
    my $action = $views{$view};
    if ($action) {
        &$action();
    }
    else {
        $response->raise_error( "Failed to find an appropriate view action." );
    }
};

if ($@) {
    $response->raise_error("An error occured: ".encode_entities($@,'&<>"\/\''));
}
###############################################################################
# All done.
###############################################################################
$response->send();
