#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w

use strict;
use warnings;
use Time::Local;
use HTML::Entities;
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Response::Reports;
use PureMessage::Manager::Widget::ToolBar;
use PureMessage::Manager::Utils qw(urlize);

###############################################################################
# Get the response object
###############################################################################
my $response = $REQUEST->get_response(
                    'PureMessage::Manager::Response::Reports',
                    'stderr_to_stdout' => 1,
                    );
exit unless $response;

###############################################################################
# Submit the form
###############################################################################
if ((defined $in{'__W!!schedule_form!schedule'}) && ($in{'__W!!schedule_form!schedule'} eq 'OK')) {
    my $v= $in{'v'};
    my $id = $in{'id'};
    my $history = $in{'history'};
    my $format = $in{'format'};
    my $mailto = '"' . $in{'mailto'} . '"';
    my $subject = '"' . $in{'subject'} . '"';
    my $start;
    my $end;
    $in{'end_day'} = encode_entities($in{'end_day'},'&<>"\/\'');
    $in{'start_day'} = encode_entities($in{'start_day'},'&<>"\/\'');
    if ((defined $in{'start_hour'}) && ($in{'start_hour'} ne '') 
        && (defined $in{'start_day'}) && ($in{'start_day'} ne '')
        && (defined $in{'start_mon'}) && ($in{'start_mon'} ne '')
        && (defined $in{'start_year'}) && ($in{'start_year'} ne '')
        ) {
        $start= timelocal(0, 0, $in{'start_hour'}, $in{'start_day'},
                               ($in{'start_mon'}  - 1), ($in{'start_year'} - 1900));
    }
    if ((defined $in{'end_hour'}) && ($in{'end_hour'} ne '')
        && (defined $in{'end_day'}) && ($in{'end_day'} ne '')
        && (defined $in{'end_mon'}) && ($in{'end_mon'} ne '')
        && (defined $in{'end_year'}) && ($in{'end_year'} ne '')
        ) {
        $end = timelocal(0, 0, $in{'end_hour'}, $in{'end_day'},
                         ($in{'end_mon'}  - 1), ($in{'end_year'} - 1900));
    }

    my $cmd;
    if ((defined $history) && ($history ne 'N/A')) {
        $cmd= "pmx-reports-mailer --html --id=$id --time-frame=$history --to=$mailto --subject=$subject";
    }
    elsif ((defined $start) && (defined $end)) {
        $cmd= "pmx-reports-mailer --html --id=$id --start=$start --end=$end --to=$mailto --subject=$subject";
    }
    else {
        $cmd= "pmx-reports-mailer --html --id=$id --to=$mailto --subject=$subject";
    }
    $cmd = urlize($cmd);
    my $comment = "Schedule Report";
    print <<"JAVASCRIPT";
<script language="javascript">
location.replace("../Services/edit.cgi?cmd=$cmd&comment=$comment");
</script>
JAVASCRIPT
}

###############################################################################
# Create the form
###############################################################################
else {
    my $tb = $response->ToolBar(
                                'buttons' => [
                                              [
                                               {
                                                   'type' => 'text',
                                                   'name' => 'schedule',
                                                   'value' => 'OK',
                                                   'text' => 'Schedule',
                                               },
                                               ],
                                              ],
                                              'state' => { 'id' => encode_entities($in{'id'},'&<>"\/\''),
                                                           'history' => encode_entities($in{'history'},'&<>"\/\''),
                                                           'start_year' => encode_entities($in{'start_year'},'&<>"\/\''),
                                                           'start_mon' => encode_entities($in{'start_mon'},'&<>"\/\''),
                                                           'start_day' => encode_entities($in{'start_day'},'&<>"\/\''),
                                                           'start_hour' => encode_entities($in{'start_hour'},'&<>"\/\''),
                                                           'end_year' => encode_entities($in{'end_year'},'&<>"\/\''),
                                                           'end_mon' => encode_entities($in{'end_mon'},'&<>"\/\''),
                                                           'end_day' => encode_entities($in{'end_day'},'&<>"\/\''),
                                                           'end_hour' => encode_entities($in{'end_hour'},'&<>"\/\'')
                                                       },
                                );

    $response->addForm(
                       'name' => 'schedule_form',
                       'fields' => [
                                    'Mail To',
                                    'Subject',
                                    ],
                       'data' => {
                           'Mail To' => "<input name=mailto>",
                           'Subject' => "<input name=subject value=\"" . encode_entities($in{'title'}) . "\">",
                       },
                       'columns' => 2,
                       'title' => 'Schedule',
                       'toolbar' => $tb,
                       'action' => 'schedule.cgi',
                       );

###############################################################################
# All done.
###############################################################################
    $response->send();
}
